<?php

namespace App\DataTables;

use App\Models\Bacheca;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class BachecaDataTableEditor extends DataTablesEditor
{
  protected $model = Bacheca::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'nome.required' => 'Il nome è richiesto',
    'descrizione.required' => 'La descrizione è richiesta',
    'icona.required' => 'L\'icona è richiesta',
    'is_attiva.required' => 'Indicare una delle due opzioni',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'nome'  => 'required',
      'descrizione' => 'nullable',
      'icona' => 'nullable|string',
      'is_attiva' => 'boolean',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'nome'  => 'required',
      'descrizione' => 'nullable',
      'icona' => 'nullable|string',
      'is_attiva' => 'boolean',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attiva'] = isset($data['is_attiva']) ? true : false;
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attiva'] = isset($data['is_attiva']) ? true : false;
    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
